// ------------------------------------------------------------
// Module     : cntr.cpp
// Created    : September 28, 2003
// Author     : M. E. Shmelyov
// Description: Example CGI application that uses webparse.*
//              Simple web counter
// ------------------------------------------------------------
// This application can be freely used and/or modified
// but please do not modify original author info
// You can remove my links from generated pages but
// please [if it would not be difficult for you] place
// some my info as HTML comment, e.g.
// <!-- Program originally created by Super-M [super-m.narod.ru] -->


#include <stdio.h>
#include <stdlib.h>
#include "webparse.h"

using namespace std;

// --- Option variables.
// Change any of those to match Your needs
char *counterPictureURL="/cgi-bin/count.gif";
char *DataFileSuffix=".dat";
bool UseReportTemplate=true;
char *ReportTemplateFileSuffix=".report";

char *countNumberStyle="position:relative; top:-22px; left:-42px; "
  "font-family:serif; font-size:8px; color:black;";
// --- end of Option variables

int main(void)
{
  if (!ParseForm())
    return 1;
  /* *****
    We have following parameters in "GET" URL:
    cid     - counter ID (used to construct filename)
    chto    - command what to do ("c" = count, "v" = view statistics)
    nc      - random number to prevent caching (optional
              because we put "Pragma: no-cache" in responce)
  ***** */
  string fileName, cidStr;
  FILE *inout;
  bool cidIsOK=true;
  int theCount, fscRet;
  cidStr = formdata["cid"];
  if (cidStr.size()>2)
    cidStr = "1"; //default if cid is too long
  fileName = cidStr + DataFileSuffix;
  inout = fopen(fileName.c_str(), "rt+"); //open statistics data file
  if (inout==NULL)
    cidIsOK = false;
  else
  {
    fscRet = fscanf(inout, "%d", &theCount); //get number of visits
    if (fscRet!=1) theCount = 0;
  }
  if (cidIsOK)
  {//if file was opened successfully
    if (formdata["chto"]=="c")
    {
      printf("Content-Type: text/javascript\nPragma: no-cache\n\n"
        "document.write(\'<a href=\\\'http:\/\/%s%s\?cid=%s&chto=v\\\'"
        " target=_blank style=\\\'text-decoration:none\\\'\'+\n"
        "\' title=\\\'%d visits counted\\\'><img src=\\\'http:\/\/%s%s\\\' border=0>"
        "<span\'+\n\' style=\\\'%s\\\'>%d</span></a>\');",
        getenv("HTTP_HOST"), getenv("SCRIPT_NAME"), cidStr.c_str(),
        theCount, getenv("HTTP_HOST"), counterPictureURL, countNumberStyle, theCount);
      fseek(inout, 0, 0);
      theCount++;
      fprintf(inout, "%d", theCount);
    }
    fclose(inout); //close statistics data file
    if (formdata["chto"]=="v")
    {
      printf("Content-Type: text/html\nPragma: no-cache\n\n");
      if (UseReportTemplate)
      {
        string TemplRepName;
        FILE *templIn;
        int intInCh;
        unsigned char Ch;
        TemplRepName = cidStr + ReportTemplateFileSuffix;
        templIn = fopen(TemplRepName.c_str(), "rb");
        if (templIn==NULL)
          UseReportTemplate=false;
        else
        {
          do
          {
            intInCh = fgetc(templIn);
            if (intInCh!=EOF)
            {
              Ch = (unsigned char)intInCh;
              if (Ch != '*')
                putc(intInCh, stdout);
              else
                printf("%d", theCount);
            }
          } while (intInCh!=EOF);
          fclose(templIn);
        }
      }
      if (!UseReportTemplate)
      {
        printf("<html><head><title>%s counter statistics</title></head>"
          "<body><h1>&quot;%s&quot; counter: Statistics</h1>"
          "<p>%d visits totally registered with this counter</p>"
          "<address>Counter application made by <a href=\'http:\/\/super-m.narod.ru/\'>"
          "Super-M</a>, 2003</address></body></html>",
          cidStr.c_str(), cidStr.c_str(), theCount);
      }
    }
  }//end if (cidIsOK)
  else
  {//if file was not open
    if (formdata["chto"]=="c")
    {
      printf("Content-Type: text/javascript\nPragma: no-cache\n\n"
        "document.write(\'<span style=\\\'background-color:white; color:red; "
        "font-size: 12px;\\\'>ERROR</span>\');");
    }
    if (formdata["chto"]=="v")
    {
      printf("Content-Type: text/html\nPragma: no-cache\n\n");
      printf("<html><head><title>Counter error</title></head>"
          "<body><h1>Counter error</h1>"
          "<p>Cannot show statistics for <b>%s</b>. This counter <u>does not exist</u>!</p>"
          "<address>Counter application made by <a href=\'http:\/\/super-m.narod.ru/\'>"
          "Super-M</a>, 2003</address></body></html>",
          cidStr.c_str());
    }
  }//end else (cidIsOK)
  return 0;
}//end main