// ------------------------------------------------------------
// File       : webparse.h
// Created    : September 26, 2003
// Author     : M. E. Shmelyov
// Description: Web form submitted data parser /header file/
// Note       : You need to compile Your program with
//              webparse.cpp file (also shipped with
//              "Son hServer" software). And, of cource, You
//              must #include "webparse.h" in Your source file.
// Instruction: Call ParseForm() function before any
//              operations with form data. Only content-type
//              application/x-www-form-urlencoded is accepted.
//              If form was submitted with content-type
//              multipart/form-data function does not process
//              form data and returns false.
//              On success ParseForm() returns true.
//              After this all form data will be contained
//              in formdata variable. It is associative
//              array (map). You can get any control-associated
//              value by using subscript.
//              E. g. formdata["user"] gives you string with
//              value of "user" form element if such exist.
//              <OPTION> tag values from <SELECT> that allows
//              multiple selection are stored under same key
//              and are separated by semicolons ";".
// ------------------------------------------------------------

#include <map>
#include <string>

extern std::map<std::string, std::string> formdata;

bool ParseForm(bool ignore_cr=true);
